#include "StdAfx.h"
#include "AutoTextListUI.h"
#include "AutoTextListHeaderUI.h"
#include "AutoTextListElementUI.h"

CAutoTextListUI::CAutoTextListUI(void)
{
	
}

CAutoTextListUI::~CAutoTextListUI(void)
{
}


LPVOID CAutoTextListUI::GetInterface(LPCTSTR pstrName)
{
	if( _tcscmp(pstrName, AUTO_TEXT_TEXT_LIST) == 0 ) 
	{
		return this;
	}

	return __super::GetInterface(pstrName);
}


LPCTSTR CAutoTextListUI::GetClass() const
{
	return AUTO_TEXT_TEXT_LIST;
}



bool CAutoTextListUI::Add(CControlUI* pControl)
{

	// Override the Add() method so we can add items specifically to
	// the intended widgets. Headers are assumed to be
	// answer the correct interface so we can add multiple list headers.
	if( pControl->GetInterface(AUTO_TEXT_TEXT_HEADER) != NULL ) {
		if( m_pHeader != pControl && m_pHeader->GetCount() == 0 ) {
			CVerticalLayoutUI::Remove(m_pHeader);
			m_pHeader = static_cast<CListHeaderUI*>(pControl);
		}
		m_ListInfo.nColumns = min(m_pHeader->GetCount(), UILIST_MAX_COLUMNS);  //lint !e666
		return CVerticalLayoutUI::AddAt(pControl, 0);
	}
	
	CAutoTextListElementUI* pListItem = static_cast<CAutoTextListElementUI*>(pControl->GetInterface(AUTO_TEXT_TEXT_ELEMENT));
	if( pListItem != NULL ) 
	{
		pListItem->SetOwner(this);
		pListItem->SetIndex(GetCount());
	}

	return __super::Add(pControl);
}

bool CAutoTextListUI::AddAt(CControlUI* pControl, int iIndex)
{
	if( pControl->GetInterface(AUTO_TEXT_TEXT_HEADER) != NULL ) {
		if( m_pHeader != pControl && m_pHeader->GetCount() == 0 ) {
			CVerticalLayoutUI::Remove(m_pHeader);
			m_pHeader = static_cast<CListHeaderUI*>(pControl);
		}
		m_ListInfo.nColumns = min(m_pHeader->GetCount(), UILIST_MAX_COLUMNS); //lint !e666
		return CVerticalLayoutUI::AddAt(pControl, 0);
	}

	IListItemUI* pListItem = static_cast<IListItemUI*>(pControl->GetInterface(AUTO_TEXT_TEXT_ELEMENT));
	if( pListItem != NULL ) {
		pListItem->SetOwner(this);
		pListItem->SetIndex(iIndex);
	}

	return __super::AddAt(pControl,iIndex);
}

